#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$06-jun-2010 12:34:44$'
#
# <one line to give the program's name and a brief idea of what it does.>
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import ConfigParser
import os

class Ini:
	def __init__(self,inifile):
		self.inifile=inifile
		#
		self.version = '1'
		self.country = '36'
		self.city = '48'
		self.country_string = 'Spain'
		self.city_string = 'Valencia'
		self.location = 'Valencia, España'
		self.temperature = 'C'
		#
		if os.path.exists(inifile)==False:
			self.write()

	def read(self):
		ini=ConfigParser.ConfigParser()
		ini.read(self.inifile)
		if not ini.has_section('Def'):
			self.write()
		else:
			self.country=ini.get('Def','Version')			
			self.country=ini.get('Def','Country')
			self.country_string=ini.get('Def','Country_string')
			self.city=ini.get('Def','city')
			self.city_string=ini.get('Def','city_string')
			self.location = ini.get('Def','location')
			self.temperature = ini.get('Def','temperature')

	def write(self):
		ini=ConfigParser.ConfigParser()
		ini.read(self.inifile)
		if not ini.has_section('Def'):
			ini.add_section('Def')
		ini.set('Def','Version',self.version)
		ini.set('Def','Country',self.country)
		ini.set('Def','Country_string',self.country_string)
		ini.set('Def','city',self.city)		
		ini.set('Def','city_string',self.city_string)		
		ini.set('Def','location',self.location)		
		ini.set('Def','temperature',self.temperature)		
		with open(self.inifile,'wb') as writefile:
			ini.write(writefile)

	def get_version(self):
		return self.version

	def set_version(self,version):
		self.version = version

	def get_country(self):
		return self.country

	def set_country(self,country):
		self.country = country

	def get_country_string(self):
		return self.country_string

	def set_country_string(self,country_string):
		self.country_string = country_string

	def get_city(self):
		return self.city
		
	def set_city(self,city):
		self.city = city

	def get_city_string(self):
		return self.city_string
		
	def set_city_string(self,city_string):
		self.city_string = city_string

	def get_location(self):
		return self.location
		
	def set_location(self,location):
		self.location = location
		
	def get_temperature(self):
		return self.temperature
		
	def set_temperature(self,temperature):
		self.temperature = temperature
		
