#! /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
__author__="atareao"
__date__ ="$29-ene-2011$"
#
# <from numbers to letters.>
#
# Copyright (C) 2011 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import gtk
import pywapi
import locale
import gettext
import os
from datetime import datetime
from Ini import Ini

APP = 'my-weather-indicator'
DIR = '/usr/share/locale-langpack'

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
_ = gettext.gettext

IDIOMA = locale.getlocale()[0][:2]

#APPDIR = '/home/atareao/Python/my-weather-indicator/'
APPDIR = '/usr/share/my-weather-indicator/'

def cambia(valor,a):
	valor = float(valor)
	if a=='F':
		return str(valor*9/5 + 32)
	elif a == 'K':
		return str(valor+273.15)
	return str(valor)

class FC(gtk.Dialog):
	def __init__(self):
		if os.path.exists(os.path.join(os.getenv("HOME"),".my-weather-indicator/"))==False:
			os.mkdir(os.path.join(os.getenv("HOME"),".my-weather-indicator/"))
		filename = os.path.join(os.getenv("HOME"),".my-weather-indicator/my-weather-indicator.ini")
		self.ini=Ini(filename)
		self.ini.read()
		#
		self.city = self.ini.get_city()
		self.city_string = self.ini.get_city_string()
		self.country = self.ini.get_country()
		self.country_string = self.ini.get_country_string()
		self.location = self.ini.get_location()
		self.temperature = self.ini.get_temperature()
		#
		location_id = self.city_string + ',' + self.country_string
		weather = pywapi.get_weather_from_google(location_id, hl = IDIOMA)
		temporal_current_conditions = weather['current_conditions']
		forecast = weather['forecasts']
		#
		gtk.Dialog.__init__(self)
		self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.set_title('my-weather-indicator | '+_('Forecast'))
		self.set_default_size(400, 200)
		self.connect('destroy', self.close_application)
		self.vbox0 = gtk.VBox(spacing = 5)
		self.vbox0.set_border_width(5)
		self.get_content_area().add(self.vbox0)
		#
		self.label11  = gtk.Label('<b>'+self.location+'</b>')
		self.label11.set_markup('<b>'+self.location+'</b>')

		self.vbox0.pack_start(self.label11,True,True)
		#
		self.hbox1 = gtk.HBox(spacing = 5)
		self.hbox1.set_border_width(5)
		self.vbox0.add(self.hbox1)
		#***************************************************************
		'''
		self.vbox1 = gtk.VBox(spacing = 5)
		self.vbox1.set_border_width(5)
		self.hbox1.add(self.vbox1)
		#
		self.label11 = gtk.Label(_('Day'))
		self.vbox1.pack_start(self.label11,False,False)
		#
		self.image12 = gtk.Image() # Imagen
		self.vbox1.pack_start(self.image12,False,False)
		#
		self.label13 = gtk.Label(_('Condition'))
		self.vbox1.pack_start(self.label13,False,False)
		#
		self.label14 = gtk.Label(_('Low temperature'))
		self.vbox1.pack_start(self.label14,False,False)
		#
		self.label15 = gtk.Label(_('High temperature'))
		self.vbox1.pack_start(self.label15,False,False)
		'''
		#***************************************************************
		self.vbox2 = gtk.VBox(spacing = 5)
		self.vbox2.set_border_width(5)
		self.hbox1.add(self.vbox2)
		#
		self.label21 = gtk.Label(forecast[0]['day_of_week'])
		self.vbox2.pack_start(self.label21,False,False)
		#
		icon_file = forecast[0]['icon'].split('/')[-1:][0][:-3]+'png'
		if os.path.exists(os.path.join(APPDIR,icon_file)) == False:
			icon_file = os.path.join(APPDIR,'na.png')
		else:
			icon_file = os.path.join(APPDIR,icon_file)
		self.image22 = gtk.Image() # Imagen
		self.image22.set_from_file(icon_file)
		self.vbox2.pack_start(self.image22,False,False)
		#
		self.label23 = gtk.Label(forecast[0]['condition'])
		self.vbox2.pack_start(self.label23,False,False)
		#
		self.label24 = gtk.Label(cambia(forecast[0]['low'],self.temperature)+' º'+self.temperature)
		self.vbox2.pack_start(self.label24,False,False)
		#
		self.label25 = gtk.Label(cambia(forecast[0]['high'],self.temperature)+' º'+self.temperature)
		self.vbox2.pack_start(self.label25,False,False)
		#***************************************************************
		self.vbox3 = gtk.VBox(spacing = 5)
		self.vbox3.set_border_width(5)
		self.hbox1.add(self.vbox3)
		#
		self.label31 = gtk.Label(forecast[1]['day_of_week'])
		self.vbox3.pack_start(self.label31,False,False)
		#
		icon_file = forecast[1]['icon'].split('/')[-1:][0][:-3]+'png'
		if os.path.exists(os.path.join(APPDIR,icon_file)) == False:
			icon_file = os.path.join(APPDIR,'na.png')
		else:
			icon_file = os.path.join(APPDIR,icon_file)
		self.image32 = gtk.Image() # Imagen
		self.image32.set_from_file(icon_file)
		self.vbox3.pack_start(self.image32,False,False)
		#
		self.label33 = gtk.Label(forecast[1]['condition'])
		self.vbox3.pack_start(self.label33,False,False)
		#
		self.label34 = gtk.Label(cambia(forecast[1]['low'],self.temperature)+' º'+self.temperature)
		self.vbox3.pack_start(self.label34,False,False)
		#
		self.label35 = gtk.Label(cambia(forecast[1]['high'],self.temperature)+' º'+self.temperature)
		self.vbox3.pack_start(self.label35,False,False)
		#***************************************************************
		self.vbox4 = gtk.VBox(spacing = 5)
		self.vbox4.set_border_width(5)
		self.hbox1.add(self.vbox4)
		#
		self.label41 = gtk.Label(forecast[2]['day_of_week'])
		self.vbox4.pack_start(self.label41,False,False)
		#
		icon_file = forecast[2]['icon'].split('/')[-1:][0][:-3]+'png'
		if os.path.exists(os.path.join(APPDIR,icon_file)) == False:
			icon_file = os.path.join(APPDIR,'na.png')
		else:
			icon_file = os.path.join(APPDIR,icon_file)
		self.image42 = gtk.Image() # Imagen
		self.image42.set_from_file(icon_file)
		self.vbox4.pack_start(self.image42,False,False)
		#
		self.label43 = gtk.Label(forecast[2]['condition'])
		self.vbox4.pack_start(self.label43,False,False)
		#
		self.label44 = gtk.Label(cambia(forecast[2]['low'],self.temperature)+' º'+self.temperature)
		self.vbox4.pack_start(self.label44,False,False)
		#
		self.label45 = gtk.Label(cambia(forecast[2]['high'],self.temperature)+' º'+self.temperature)
		self.vbox4.pack_start(self.label45,False,False)
		#***************************************************************
		self.vbox5 = gtk.VBox(spacing = 5)
		self.vbox5.set_border_width(5)
		self.hbox1.add(self.vbox5)
		#
		self.label51 = gtk.Label(forecast[3]['day_of_week'])
		self.vbox5.pack_start(self.label51,False,False)
		#
		icon_file = forecast[3]['icon'].split('/')[-1:][0][:-3]+'png'
		if os.path.exists(os.path.join(APPDIR,icon_file)) == False:
			icon_file = os.path.join(APPDIR,'na.png')
		else:
			icon_file = os.path.join(APPDIR,icon_file)
		self.image52 = gtk.Image() # Imagen
		self.image52.set_from_file(icon_file)
		self.vbox5.pack_start(self.image52,False,False)
		#
		self.label53 = gtk.Label(forecast[3]['condition'])
		self.vbox5.pack_start(self.label53,False,False)
		#
		self.label54 = gtk.Label(cambia(forecast[3]['low'],self.temperature)+' º'+self.temperature)
		self.vbox5.pack_start(self.label54,False,False)
		#
		self.label55 = gtk.Label(cambia(forecast[3]['high'],self.temperature)+' º'+self.temperature)
		self.vbox5.pack_start(self.label55,False,False)
		#
		self.button = gtk.Button(_('Ok'))
		self.button.connect('clicked', self.on_exit_activate)
		self.vbox0.pack_start(self.button,True,True)
		#
		self.show_all()
		#
		#
		#
	def close_application(self, widget, event = None, data=None):
		self.hide()
	
	def on_exit_activate(self,widget):
		self.hide()

if __name__ == "__main__":
	cm = FC()
	cm.run()
	exit(0)
