#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$30/10/2010'
#
# Touchpad-Indicator
# An indicator to show the status of the touchpad
#
# Adding keybiding
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import os
import gobject
import gtk
import appindicator
import urllib2
import pynotify
import locale
import gettext
import glib
from Ini import Ini
import pywapi
import time
import preferences
from datetime import datetime
from forecastw import FC
from preferences import CM

APP = 'my-weather-indicator'
DIR = '/usr/share/locale-langpack'

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
_ = gettext.gettext

IDIOMA = locale.getlocale()[0][:2]

#APPDIR = '/home/atareao/Python/my-weather-indicator/'
APPDIR = '/usr/share/my-weather-indicator/'

class MWI():
	
	def __init__(self):
		if os.path.exists(os.path.join(os.getenv("HOME"),".my-weather-indicator/"))==False:
			os.mkdir(os.path.join(os.getenv("HOME"),".my-weather-indicator/"))
		filename = os.path.join(os.getenv("HOME"),".my-weather-indicator/my-weather-indicator.ini")
		self.ini=Ini(filename)
		error=True
		while error:
			try:
				self.ini.read()	
				error=False
			except:
				p=preferences.CM(selected_country = self.ini.get_country(),selected_city = self.ini.get_city(),selected_temperature = self.ini.get_temperature())
				p.run()
				self.ini.set_country(p.selected_country)
				self.ini.set_country_string(p.selected_country_string)
				self.ini.set_city(p.selected_city)
				self.ini.set_city_string(p.selected_city_string)
				self.ini.set_location(p.selected_location)
				self.ini.set_temperature(p.selected_temperature)
				self.ini.write()
				error=True
		#
		self.city = self.ini.get_city()
		self.city_string = self.ini.get_city_string()
		self.country = self.ini.get_country()
		self.country_string = self.ini.get_country_string()
		self.location = self.ini.get_location()
		self.temperature = self.ini.get_temperature()
		'''
		Categorias:
		* CATEGORY_APPLICATION_STATUS
		* CATEGORY_COMMUNICATIONS
		* CATEGORY_SYSTEM_SERVICES
		* CATEGORY_HARDWARE
		* CATEGORY_OTHER
		'''
		self.indicator = appindicator.Indicator('My-Weather-Indicator', 'My-Weather-Indicator', appindicator.CATEGORY_APPLICATION_STATUS)
		#
		#
		#
		#self.indicator.set_icon(icon_enabled)
		#self.indicator.set_attention_icon(icon_disabled)
		'''
		Estados:
		* STATUS_PASSIVE : The icon is hidden
		* STATUS_ACTIVE : The icon is visible
		* STATUS_ATTENTION : The icon changes to the attention icon, requesting some kind of interaction with the user
		'''	
		self.indicator.set_status(appindicator.STATUS_ACTIVE)
		#
		self.current_conditions = None
		self.set_menu()
		#
		glib.timeout_add_seconds(600, self.work)
	
	def set_menu(self):
		self.menu = gtk.Menu()	
		#
		location_id = self.city_string + ',' + self.country_string
		weather = pywapi.get_weather_from_google(location_id, hl = IDIOMA)
		temporal_current_conditions = weather['current_conditions']
		forecast = weather['forecasts']
		conditions_changed = False
		if len(temporal_current_conditions)!=0:
			if self.current_conditions == None \
			or temporal_current_conditions['temp_c'] != self.current_conditions['temp_c'] \
			or temporal_current_conditions['humidity'] != self.current_conditions['humidity'] \
			or temporal_current_conditions['wind_condition'] != self.current_conditions['wind_condition'] \
			or temporal_current_conditions['condition'] != self.current_conditions['condition'] \
			or temporal_current_conditions['icon'] != self.current_conditions['icon']:
				conditions_changed = True
			self.current_conditions = temporal_current_conditions
			#
			data=[]
			self_menu_data=[]
			data.append(_('Location')+': '+self.location)
			data.append(_('Temperature')+': '+cambia(self.current_conditions['temp_c'],self.temperature)+' º'+self.temperature)
			data.append(self.current_conditions['humidity'])
			data.append(self.current_conditions['wind_condition'])
			data.append(self.current_conditions['condition'])
			for element in data:
				gmi=gtk.MenuItem(element)
				self.menu.append(gmi)
				gmi.show()
			#
			self.menu_separator1=gtk.MenuItem()
			self.menu_forecast=gtk.MenuItem(_('Forecast'))
			self.menu_set_location=gtk.MenuItem(_('Preferences'))
			self.menu_refresh_weather=gtk.MenuItem(_('Refresh weather'))
			self.menu_exit=gtk.MenuItem(_('Exit'))
			self.menu_separator2=gtk.MenuItem()
			self.menu_about=gtk.MenuItem(_('About'))
			self.menu_image=gtk.ImageMenuItem()
			#***************************************************************
			hora = datetime.time(datetime.now()).hour
			if hora < 7 or hora > 19:
				icon_file = self.current_conditions['icon'].split('/')[-1:][0][:-4]+'_n.png'
			else:
				icon_file = self.current_conditions['icon'].split('/')[-1:][0][:-3]+'png'
			if os.path.exists(os.path.join(APPDIR,icon_file)) == False:
				icon_file = os.path.join(APPDIR,'na.png')
			else:
				icon_file = os.path.join(APPDIR,icon_file)
			#***************************************************************
			imagen = gtk.Image()
			imagen.set_from_file(icon_file)
			self.menu_image.set_image(imagen)
			#
			self.menu.append(self.menu_separator1)
			self.menu.append(self.menu_forecast)
			self.menu.append(self.menu_set_location)
			self.menu.append(self.menu_refresh_weather)
			self.menu.append(self.menu_exit)
			self.menu.append(self.menu_separator2)
			self.menu.append(self.menu_about)
			self.menu.append(self.menu_image)	
			if conditions_changed == True:
				msg = _('Conditions in ')+' '+self.location+'\n'
				msg += _('Temperature')+': '+cambia(self.current_conditions['temp_c'],self.temperature)+' º'+self.temperature+'\n'
				msg += self.current_conditions['humidity']+'\n'
				msg += self.current_conditions['wind_condition']+'\n'			
				msg += self.current_conditions['condition']
				self.notification = pynotify.Notification ('My-Weather-Indicator',msg,icon_file)
				self.notification.show()
			self.indicator.set_icon(icon_file)
			self.indicator.set_status (appindicator.STATUS_ACTIVE)
			#
			self.menu_separator2.show()
			self.menu_forecast.show()
			self.menu_set_location.show()
			self.menu_refresh_weather.show()
			self.menu_exit.show()
			self.menu_separator1.show()
			self.menu_about.show()
			self.menu_image.show()
			#
			self.menu_forecast.connect('activate',self.menu_forecast_response)
			self.menu_set_location.connect('activate',self.menu_set_location_response)
			self.menu_refresh_weather.connect('activate', self.menu_refresh_weather_response)
			self.menu_exit.connect('activate', self.menu_exit_response)
			self.menu_about.connect('activate', self.menu_about_response)
			#menu.show()
			self.indicator.set_menu(self.menu)
		
	def work(self):
		self.set_menu()
		return True
		
	def menu_forecast_response(self,widget):
		fc = FC()
		fc.run()

	def menu_set_location_response(self,widget):
		cm = CM(selected_country = self.country, selected_city = self.city, selected_temperature = self.temperature)
		cm.run()
		if cm.ok == True:
			self.country = cm.selected_country
			self.country_string = cm.selected_country_string
			self.city = cm.selected_city
			self.city_string = cm.selected_city_string
			self.ini.set_country(cm.selected_country)
			self.ini.set_country_string(cm.selected_country_string)
			self.ini.set_city(cm.selected_city)
			self.ini.set_city_string(cm.selected_city_string)
			self.ini.set_location(cm.selected_location)
			self.ini.set_temperature(cm.selected_temperature)
			self.ini.write()	
			self.ini.read()
			self.city = self.ini.get_city()
			self.city_string = self.ini.get_city_string()
			self.country = self.ini.get_country()
			self.country_string = self.ini.get_country_string()
			self.location = self.ini.get_location()
			self.temperature = self.ini.get_temperature()
			self.set_menu()
		
	def menu_refresh_weather_response(self,widget):
		self.set_menu()

	def menu_exit_response(self,widget):
		exit(0)

	def menu_about_response(self,widget):
		ad=gtk.AboutDialog()
		ad.set_name('My-Weather-Indicator')
		ad.set_version('0.2.4')
		ad.set_copyright('Copyrignt (c) 2011\nLorenzo Carbonell')
		ad.set_comments(_('A weather indicator'))
		ad.set_license(_(''+
		'This program is free software: you can redistribute it and/or modify it\n'+
		'under the terms of the GNU General Public License as published by the\n'+
		'Free Software Foundation, either version 3 of the License, or (at your option)\n'+
		'any later version.\n\n'+
		'This program is distributed in the hope that it will be useful, but\n'+
		'WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n'+
		'or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for\n'+
		'more details.\n\n'+
		'You should have received a copy of the GNU General Public License along with\n'+
		'this program.  If not, see <http://www.gnu.org/licenses/>.'))		
		ad.set_website('http://www.atareao.es')
		ad.set_website_label('http://www.atareao.es')
		ad.set_authors(['Eugene Kaznacheev <qetzal@gmail.com>','Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_documenters(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		#ad.set_logo(logo)
		#ad.set_logo_icon_name(icon_name)
		ad.set_program_name('My-Weather-Indicator')
		ad.run()
		ad.hide()
def cambia(valor,a):
	valor = float(valor)
	if a=='F':
		return str(valor*9/5 + 32)
	elif a == 'K':
		return str(valor+273.15)
	return str(valor)

if __name__ == "__main__":
	mwi=MWI()
	gtk.main()
