#! /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
__author__="atareao"
__date__ ="$29-ene-2011$"
#
# <from numbers to letters.>
#
# Copyright (C) 2011 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import os
import gtk
import pywapi
import locale
import gettext

APP = 'my-weather-indicator'
DIR = '/usr/share/locale-langpack'

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
_ = gettext.gettext

#APPDIR = '/home/atareao/Python/my-weather-indicator/'
APPDIR = '/usr/share/my-weather-indicator/'

IDIOMA = locale.getlocale()[0][:2]

def ejecuta(comando):
	args = shlex.split(comando)
	p = subprocess.call(args)
	return p

class CM(gtk.Dialog): # needs GTK, Python, Webkit-GTK
	def __init__(self,selected_country = 36, selected_city = 48, selected_temperature = 'C'):
		self.selected_country = int(selected_country)
		self.selected_city = int(selected_city)
		self.selected_country_string = 'Spain'
		self.selected_city_string = 'Valencia'
		self.location = 'Valencia, España'
		self.selected_temperature = selected_temperature
		#
		self.country = []
		lista = pywapi.get_countries_from_google(hl = IDIOMA)
		lista_en= pywapi.get_countries_from_google(hl = 'en')
		for i in range(0,len(lista)):
			self.country.append([lista[i]['name'],lista[i]['iso_code'],lista_en[i]['name']])
		self.country.sort()
		#
		gtk.Dialog.__init__(self)
		self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.set_title('my-weather-indicator | '+_('Preferences'))
		self.set_default_size(400, 150)
		self.connect('destroy', self.close_application)
		#
		self.vbox1 = gtk.VBox(spacing = 5)
		self.vbox1.set_border_width(5)
		self.get_content_area().add(self.vbox1)
		#***************************************************************
		self.hbox1 = gtk.HBox(spacing = 5)
		self.hbox1.set_border_width(5)
		self.vbox1.add(self.hbox1)
		#
		self.label1 = gtk.Label(_('Country')+':')
		self.hbox1.pack_start(self.label1,False,False)
		#
		self.liststore1 = gtk.ListStore(str,str,str)
		for el in self.country:
			self.liststore1.append([el[0],el[1],el[2]])
		self.combobox1 = gtk.ComboBox(self.liststore1)
		cell1 = gtk.CellRendererText()
		self.combobox1.pack_start(cell1, True)
		self.combobox1.add_attribute(cell1, 'text', 0)  		
		self.combobox1.connect('changed', self.combobox1_changed)		
		self.hbox1.pack_start(self.combobox1,True,True)
		#***************************************************************
		self.hbox2 = gtk.HBox(spacing = 5)
		self.hbox2.set_border_width(5)
		self.vbox1.add(self.hbox2)
		#
		self.label2 = gtk.Label(_('City')+':')
		self.hbox2.pack_start(self.label2,False,False)
		#
		self.liststore2 = gtk.ListStore(str,str)
		self.combobox2 = gtk.ComboBox(self.liststore2)
		cell2 = gtk.CellRendererText()
		self.combobox2.pack_start(cell2, True)
		self.combobox2.add_attribute(cell2, 'text', 0)  
		self.hbox2.pack_start(self.combobox2,True,True)
		#***************************************************************
		self.hbox3 = gtk.HBox(spacing = 5)
		self.hbox3.set_border_width(5)
		self.vbox1.add(self.hbox3)
		#
		self.label3 = gtk.Label(_('Temperature')+':')
		self.hbox3.pack_start(self.label3,False,False)
		#
		self.liststore3 = gtk.ListStore(str,str)
		self.liststore3.append([_('Celsius'),'C'])
		self.liststore3.append([_('Farenheit'),'F'])
		self.liststore3.append([_('Kelvin'),'K'])
		self.combobox3 = gtk.ComboBox(self.liststore3)
		cell3 = gtk.CellRendererText()
		self.combobox3.pack_start(cell3, True)
		self.combobox3.add_attribute(cell3, 'text', 0)  
		self.hbox3.pack_start(self.combobox3,True,True)
		#***************************************************************
		self.checkbutton1 = gtk.CheckButton(_('Autostart'))		
		self.vbox1.pack_start(self.checkbutton1,True,True)		
		#***************************************************************
		self.hbox4 = gtk.HBox(spacing = 5)
		self.hbox4.set_border_width(5)
		self.vbox1.add(self.hbox4)
		#
		self.button1 = gtk.Button(_('Ok'))
		self.button1.connect('clicked',self.close_ok)
		self.hbox4.pack_start(self.button1,True,True)
		#
		self.button2 = gtk.Button(_('Cancel'))
		self.button2.connect('clicked',self.close_cancel)
		self.hbox4.pack_start(self.button2,True,True)
		#***************************************************************
		if os.path.exists(os.path.join(os.getenv("HOME"),".config/autostart/my-weather-indicator.py.desktop")):
			self.checkbutton1.set_active(True)
		self.combobox1.set_active(self.selected_country)	
		self.combobox2.set_active(self.selected_city)
		if self.selected_temperature == 'C':
			self.combobox3.set_active(0)
		elif self.selected_temperature == 'F':
			self.combobox3.set_active(1)
		elif self.selected_temperature == 'K':
			self.combobox3.set_active(2)
		#
		self.show_all()
		#
		#
		#
	def close_application(self, widget, event, data=None):
		self.hide()
	
	def close_ok(self,widget):
		self.selected_country = self.combobox1.get_active()
		self.selected_country_string = self.liststore1.get_value(self.combobox1.get_active_iter(),2)
		self.selected_city = self.combobox2.get_active()
		self.selected_city_string = self.liststore2.get_value(self.combobox2.get_active_iter(),1)
		self.selected_location = self.combobox2.get_active_text() +', '+self.combobox1.get_active_text()
		self.selected_temperature = self.liststore3.get_value(self.combobox3.get_active_iter(),1)
		filestart = os.path.join(os.getenv("HOME"),".config/autostart/my-weather-indicator.py.desktop")
		if self.checkbutton1.get_active():
			if not os.path.exists(filestart):
				os.symlink('/usr/share/my-weather-indicator/my-weather-indicator.py.desktop',filestart)
		else:		
			if os.path.exists(filestart):
				os.remove(filestart)
		self.ok = True
		self.hide()

	def close_cancel(self,widget):
		self.selected_country = None
		self.selected_country_string = None
		self.selected_city = None
		self.selected_city_string = None
		self.selected_location = None
		self.selected_temperature = None
		self.ok = False
		self.hide()

	def combobox1_changed(self,widget):
		pais = self.liststore1.get_value(self.combobox1.get_active_iter(),1)
		self.city = []
		lista = pywapi.get_cities_from_google(pais,IDIOMA)
		lista_en = pywapi.get_cities_from_google(pais,'en')			
		for i in range(0,len(lista)):
			self.city.append([lista[i]['name'],lista_en[i]['name']])
		self.city.sort()
		self.liststore2.clear()
		for el in self.city:
			self.liststore2.append([el[0],el[1]])
		self.combobox2.set_active(0)

	def numera(self,widget):
		pass
		
	def on_exit_activate(self,widget):
		exit(0)

if __name__ == "__main__":	
	cm = CM()
	cm.run()
	print cm.selected_country
	print cm.selected_country_string
	print cm.selected_city
	print cm.selected_city_string
	print cm.selected_location
	print cm.selected_temperature
	exit(0)
